<?php

if ($step == 'vcharset_update_bbclosedreason')
{
	update_settings('bbclosedreason', $vbphrase['vcharset_please_standby']);
	build_options();
	$step_done = true;
}

if ($step == 'vcharset_turn_vbulletin_off')
{
	update_settings('bbactive', 0);
	build_options();
	$step_done = true;
}

if ($step == 'vcharset_empty_character_stripper')
{
	update_settings('blankasciistrip', '');
	build_options();
	$step_done = true;
}

if ($step == 'vcharset_truncate_word_table')
{
	$db->query_write("TRUNCATE TABLE " . TABLE_PREFIX . "word");
	$step_done = true;
}

if ($step == 'vcharset_truncate_postindex_table')
{
	$db->query_write("TRUNCATE TABLE " . TABLE_PREFIX . "postindex");
	$step_done = true;
}

if ($step == 'vcharset_read_database_tables')
{
	$db->query_write("TRUNCATE TABLE charset_convert");
	
	$special_vcharset_tables = array('charset_convert', 'charset_step');
	
	$i = 0;
	
	$get_tables = $db->query_read("SHOW TABLES");
	
	while($get_table = $db->fetch_array($get_tables))
	{
		$get_table = array_values($get_table);
		$table = $get_table[0];
		
		if (in_array($table, $special_vcharset_tables))
		{
			continue;
		}
		
		$get_num_rows = $db->query_first("SELECT COUNT(*) AS records FROM " . $table);
		
		$db->query_write("INSERT INTO charset_convert SET item = '" . $table . "', records = " . $get_num_rows['records']);
		
		$i++;
	}
	
	update_settings('vcharset_num_tables', $i);
	build_options();
	
	$vbulletin->db->free_result($get_tables);
	$step_done = true;
}

if ($step == 'vcharset_database_analyzing')
{
	$get_analyzed = $db->query_first("SELECT COUNT(*) AS num FROM charset_convert WHERE analyzed = 1");
	
	$get_tables = $vbulletin->db->query_read("SELECT * FROM charset_convert WHERE analyzed = 0 LIMIT 4");
	
	while($get_table = $db->fetch_array($get_tables))
	{
		$table = $get_table['item'];
		$primary_keys = array();
		$convertable_fields = array();
		$full_text = array();
		$table_prefix = TABLE_PREFIX;
		
		$get_indexes = $db->query_read("SHOW INDEX FROM " . $table);
		while ($index = $db->fetch_array($get_indexes))
		{
			if ($index['Index_type'] == 'FULLTEXT')
			{
				$full_text[$index['Key_name']][] = $index['Column_name'];
			}
		}
		$vbulletin->db->free_result($get_indexes);
		
		$get_fields = $db->query_read("SHOW COLUMNS FROM " . $table);
		while ($field = $db->fetch_array($get_fields))
		{
			if ($field['Key'] == 'PRI')
			{
				$primary_keys[] = $field['Field'];
			}
			
			if (strpos($field['Type'], 'int(') !== false OR strpos($field['Type'], 'float') !== false OR strpos($field['Type'], 'blob') !== false OR strpos($field['Type'], 'date') !== false)
			{
				// do nothing
			}
			else
			{
				$convertable_fields[] = $field['Field'];
			}
		}
		$vbulletin->db->free_result($get_fields);
		
		$db->query_write("UPDATE charset_convert SET analyzed = 1, convertable_fields = '" . $db->escape_string(serialize($convertable_fields)) . "', primary_keys = '" . $db->escape_string(serialize($primary_keys)) . "', full_text = '" . $db->escape_string(serialize($full_text)) . "'" . (count($convertable_fields) == 0 || count($primary_keys) == 0 || $get_table['records'] == 0 || ($table_prefix != '' && (strpos($table, $table_prefix) === false || strpos($table, $table_prefix) > 0)) ? ", converted = 1" : "")  . ($table_prefix != '' && (strpos($table, $table_prefix) === false || strpos($table, $table_prefix) > 0) ? ", collation = 1" : "") . " WHERE item = '" . $table . "'");
	}
	$vbulletin->db->free_result($get_tables);
	
	$percent = round(($get_analyzed['num'] / $vbulletin->options['vcharset_num_tables']) * 100);
	
	if ($vbulletin->options['vcharset_num_tables'] != $get_analyzed['num'])
	{
		echo "myJsProgressBarHandler.setPercentage('progress_" . $step . "','" . $percent . "');\n";
		echo "vcharset_execute_step('" . $step . "');\n";
		$step_done = false;
	}
	else
	{
		echo "myJsProgressBarHandler.setPercentage('progress_" . $step . "','100');\n";
		$step_done = true;
	}
}

if ($step == 'vcharset_tables_confirmation')
{
	print_table_start();
	print_table_header($vbphrase['vcharset_converter']);
	print_description_row($vbphrase['confirmation_explanation']);
	print_table_footer();
	
	$get_tables = $db->query_read("SELECT * FROM charset_convert");
	
	$row_array = array('Table', 'Records', 'Convertable Fields', 'Primary Keys', 'Full Text');
	
	!$vbulletin->options['vcharset_update_database_collation_only'] ? $row_array[] = 'Convert Content? <input type="checkbox" name="allbox" title="Check All" onclick="js_toggle(this.form, \'confirm_tables_\', this.checked);" checked="checked" />' : '';
	$vbulletin->options['vcharset_mysql_41_compatible'] ? $row_array[] = 'Convert Collation? <input type="checkbox" name="allbox" title="Check All" onclick="js_toggle(this.form, \'confirm_collation_\', this.checked);" checked="checked" />' : '';
	
	print_form_header('vcharset', 'saveconvettable', false, false, 'tables');
	print_table_start();
	print_cells_row($row_array, true, '', 0, 'middle', false, false);
	
	$i = 0;
	
	while ($table = $db->fetch_array($get_tables))
	{
		$row_array = array($table['item'], $table['records'], count(unserialize($table['convertable_fields'])), count(unserialize($table['primary_keys'])), count(unserialize($table['full_text'])));
		if (!$vbulletin->options['vcharset_update_database_collation_only'])
		{
			$row_array[] = (!$table['converted'] ? '<input type="checkbox" id="confirm_tables_' . $i . '" name="confirm_tables[' . $table['item'] . ']" checked="checked" />' : '');
		}
		$vbulletin->options['vcharset_mysql_41_compatible'] ? $row_array[] = '<input type="checkbox" id="confirm_collation_' . $i . '" name="confirm_collation[' . $table['item'] . ']" ' . ($table['collation'] ? '' : ' checked="checked"') . ' />' : '';
		print_cells_row($row_array, false, '', 0, '', false, false);
		$i++;
	}
	
	print_submit_row($vbphrase['save'], $vbphrase['reset'], ($vbulletin->options['vcharset_mysql_41_compatible'] ? 7 : 6));
	
	print_myfooter();
	print_cp_footer(1);
}

if ($step == 'vcharset_add_temporary_columns')
{
	$get_tables = $db->query_read("SELECT item, temporary FROM charset_convert WHERE convertit = 1");
	
	$modified_tables = 0;
	$i = 1;
	
	while ($table = $db->fetch_array($get_tables))
	{
		if ($table['temporary'])
		{
			$modified_tables++;
		}
		elseif (!$table['temporary'] & $i <= 5)
		{
			$db->hide_errors();
			$db->query_write("ALTER TABLE " . $table['item'] . " ADD charset_convert TINYINT(1) UNSIGNED NOT NULL DEFAULT '0'");
			$db->query_write("ALTER TABLE " . $table['item'] . " ADD INDEX (`charset_convert`)");
			$db->query_write("UPDATE charset_convert SET temporary = 1 WHERE item = '" . $table['item'] . "'");
			$db->show_errors();
			$i++;
		}
		elseif (!$table['temporary'] & $i == 6)
		{
			break;
		}
	}
	
	if ($vbulletin->options['vcharset_num_tables_convert'] != $modified_tables)
	{
		$percent = round(($modified_tables / $vbulletin->options['vcharset_num_tables_convert']) * 100);
		echo "myJsProgressBarHandler.setPercentage('progress_" . $step . "','" . $percent . "');\n";
		echo "vcharset_execute_step('" . $step . "');\n";
		$step_done = false;
	}
	else
	{
		echo "myJsProgressBarHandler.setPercentage('progress_" . $step . "','100');\n";
		$step_done = true;
	}
}

if ($step == 'vcharset_convert_database')
{
	// fake step
}

if ($step == 'vcharset_remove_temporary_columns')
{
	$get_tables = $db->query_read("SELECT item, temporary FROM charset_convert WHERE convertit = 1");
	
	$modified_tables = 0;
	$i = 1;
	
	while ($table = $db->fetch_array($get_tables))
	{
		if (!$table['temporary'])
		{
			$modified_tables++;
		}
		elseif ($table['temporary'] & $i <= 5)
		{
			$db->hide_errors();
			$db->query_write("ALTER TABLE " . $table['item'] . " DROP INDEX charset_convert");
			$db->query_write("ALTER TABLE " . $table['item'] . " DROP charset_convert");
			$db->query_write("UPDATE charset_convert SET temporary = 0 WHERE item = '" . $table['item'] . "'");
			$db->show_errors();
			$i++;
		}
		elseif ($table['temporary'] & $i == 6)
		{
			break;
		}
	}
	
	if ($vbulletin->options['vcharset_num_tables_convert'] != $modified_tables)
	{
		$percent = round(($modified_tables / $vbulletin->options['vcharset_num_tables_convert']) * 100);
		echo "myJsProgressBarHandler.setPercentage('progress_" . $step . "','" . $percent . "');\n";
		echo "vcharset_execute_step('" . $step . "');\n";
		$step_done = false;
	}
	else
	{
		echo "myJsProgressBarHandler.setPercentage('progress_" . $step . "','100');\n";
		$step_done = true;
	}
}

if ($step == 'vcharset_update_database_collation')
{
	if ($vbulletin->options['vcharset_mysql_41_compatible'])
	{
		$options_array = array();
		foreach (explode('|', $vbulletin->options['vcharset_new_database_charset']) AS $key => $value)
		{
			$single_option = explode(':', $value);
			$options_array["$single_option[0]"] = $single_option[1];
		}
		
		$db->query_write("ALTER DATABASE `" . $vbulletin->config['Database']['dbname'] . "` CHARACTER SET " . $options_array['charset'] . " COLLATE " . $options_array['collation']);
	}
	
	$step_done = true;
}

if ($step == 'vcharset_update_tables_collation')
{
	// THIS STEP IS BASED ON A CODE PROVIDED BY El_Muerte, THANKS TO HIM.
	if ($vbulletin->options['vcharset_mysql_41_compatible'])
	{
		$options_array = array();
		foreach (explode('|', $vbulletin->options['vcharset_new_database_charset']) AS $key => $value)
		{
			$single_option = explode(':', $value);
			$options_array["$single_option[0]"] = $single_option[1];
		}
		
		$typetable = array(
			'char' => 'binary',
			'varchar' => 'varbinary',
			'text' => 'blob',
			'tinytext' => 'tinyblob',
			'mediumtext' => 'mediumblob',
			'longtext' => 'longblob',
			'enum' => 'enum',
		);
		
		$get_tables = $db->query_read("SELECT * FROM charset_convert WHERE collation = 0 AND collation_convert = 1 LIMIT 1");
		
		$i = $vbulletin->db->num_rows($get_tables);
		
		while($get_table = $db->fetch_array($get_tables))
		{
			$get_table = array_values($get_table);
			$table = $get_table[0];
			
			// Survive the datastore table
			if ($table == TABLE_PREFIX . 'datastore')
			{
				$datastoreitems = array();
				$get_datastore_table = $vbulletin->db->query_read("SELECT title, data FROM " . $table);
				while ($datastore_item = $vbulletin->db->fetch_array($get_datastore_table))
				{
					$datastoreitems["$datastore_item[title]"] = $datastore_item['data'];
				}
				$vbulletin->db->free_result($get_datastore_table);
			}
			
			$db->query_write("ALTER TABLE `" . $table . "` CHARACTER SET " . $options_array['charset'] . " COLLATE " . $options_array['collation']);
			
			$full_text = array();
			$get_indexes = $db->query_read("SHOW INDEX FROM " . $table);
			while ($index = $db->fetch_array($get_indexes))
			{
				if ($index['Index_type'] == 'FULLTEXT')
				{
					$full_text[$index['Key_name']][] = $index['Column_name'];
				}
			}
			
			if(count($full_text) > 0)
			{
				foreach($full_text as $key => $columns)
				{
					$vbulletin->db->query_write("ALTER TABLE ". $table . " DROP INDEX " . $key);
				} 
			}
			
			$get_fields = $db->query_read("SHOW FULL COLUMNS FROM " . $table);
			
			while ($field = $db->fetch_array($get_fields))
			{
				list($type) = explode('(', $field['Type']);
				
				if (!isset($typetable[$type]))
				{
					continue;
				}
				
				if (strpos($field['Collation'], $options_array['charset']) !== false)
				{
					continue;
				}
				
				$attrib = " DEFAULT ";
				
				if ($field['Default'] == 'NULL')
				{
					$attrib .= "NULL ";
				}
				else
				{
					$attrib .= "'" . $vbulletin->db->escape_string($field['Default']) . "' ";
				}
				
				if ($field['Null'] == 'YES')
				{
					$attrib .= "NULL ";
				}
				else
				{
					$attrib .= "NOT NULL ";
				}
				
				if ($typetable[$type] != $type)
				{
					$temptype = preg_replace('/'. $type .'/i', $typetable[$type], $field['Type']);
					$db->query_write("ALTER TABLE " . $table . " MODIFY " . $field['Field'] . " " . $temptype . $attrib);
				}
				
				$db->query_write("ALTER TABLE " . $table . " MODIFY " . $field['Field'] . " " . $field['Type'] . " CHARACTER SET " . $options_array['charset']  . " COLLATE " . $options_array['collation'] . " " . $attrib);
			}
			
			if(count($full_text) > 0)
			{
				foreach($full_text as $key => $columns)
				{
					$vbulletin->db->query_write("ALTER TABLE ". $table . " ADD FULLTEXT (" . implode(",", $columns) . ")");
				}
			}
			
			$vbulletin->db->query_write("UPDATE charset_convert SET collation = 1 WHERE item = '" . $table . "'");
			
			// Survive the datastore table
			if ($table == TABLE_PREFIX . 'datastore')
			{
				foreach ($datastoreitems AS $title => $data)
				{
					$vbulletin->db->query_write("UPDATE " . $table . " SET data = '" . $db->escape_string($data) . "' WHERE title = '" . $title . "'");
				}
				unset($datastoreitems);
			}
		}
		
		if ($i > 0)
		{
			$get_converted = $db->query_first("SELECT COUNT(*) AS num FROM charset_convert WHERE collation = 1 AND collation_convert = 1");
			$percent = round(($get_converted['num'] / $vbulletin->options['vcharset_num_tables_convert_collation']) * 100);
			echo "myJsProgressBarHandler.setPercentage('progress_" . $step . "','" . $percent . "');\n";
			echo "vcharset_execute_step('" . $step . "');\n";
			$step_done = false;
		}
		else
		{
			echo "myJsProgressBarHandler.setPercentage('progress_" . $step . "','100');\n";
			$step_done = true;
		}
	}
}

if ($step == 'vcharset_rebuild_datastore')
{
	/* Things must be updated.
	languagecache
	stylecache
	options
	smiliecache
	iconcache
	bbcodecache
	usergroupcache
	* forumcache
	ranks
	birthdaycache */
	
	
	// bbcode
	require_once(DIR . '/includes/functions_calendar.php');
	build_bbcode_cache();
	
	//events
	require_once(DIR . '/includes/functions_databuild.php');
	build_events();
	
	//  forum permissions 
	build_forum_permissions();
	
	// holiday
	require_once(DIR . '/includes/functions_databuild.php');
	build_events();
	
	// language
	require_once(DIR . '/includes/adminfunctions_language.php');
	$options = fetch_supported_charsets_iconv_array();
	$vbulletin->db->query_write("UPDATE " . TABLE_PREFIX . "language SET charset = '" . $options[$vbulletin->options['vcharset_destination']] . "'");
	build_language_datastore();
	
	// product
 	build_product_datastore();
	
	// ranks
 	require_once(DIR . '/includes/functions_ranks.php');
 	build_ranks();
	
	// reputationlevel
	require_once(DIR . '/includes/adminfunctions_reputation.php');
	build_reputationids();
	
	// setting
 	build_options();
	
	// style
	require_once(DIR . '/includes/adminfunctions_template.php');
	build_template_parentlists();
	build_all_styles();
	build_style_datastore();
	
	$step_done = true;
}

if ($step == 'vcharset_turn_vbulletin_on')
{
	update_settings('bbactive', 1);
	build_options();
	$step_done = true;
}

if ($step == 'vcharset_report')
{
	$startTime = $converter_steps[1]['timestarted'];
	$stepsCount = count($converter_steps) - 1;
	$endTime = $converter_steps["$stepsCount"]['timefinished'];
	$total_time = $endTime - $startTime;
	$total_time_hours = floor($total_time / 3600);
	$total_time_minutes = floor(($total_time - (3600 * $total_time_hours)) / 60);
	$total_time_seconds = ($total_time - (3600 * $total_time_hours)) - ($total_time_minutes * 60);
	
	print_table_start();
	print_table_header($vbphrase['vcharset_converter']);
	print_description_row('<b>Congratulation!</b> the conversion had been completed, it took ' . ($total_time_hours ? $total_time_hours . ' hour(s), ' : '') . ($total_time_minutes ? $total_time_minutes . ' minute(s) ' : '') . ($total_time_seconds ? 'and ' . $total_time_seconds . ' second(s).' : ''), $steps_explain);
	print_table_footer();
}
?>